=== debian/changelog ===
faust (2.14.4~repack2-1) unstable; urgency=medium

  * New upstream version 2.14.4~repack2
    * Remove spelling patch (applied upstream)
  * Exclude pre-built .dll/.so files from source package
  * Refresh d/copyright(_hints)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 06 Feb 2019 09:18:17 +0100

faust (2.13.14~git20181219.1.cd34eccb.repack1-1) unstable; urgency=medium

  * New upstream version 2.13.14~git20181219.1.cd34eccb.repack1
    (Closes: #916886)

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/control: Set Vcs-* to salsa.debian.org
  * d/changelog: Remove trailing whitespaces
  * d/watch: Use https protocol

  [ Felipe Sateler ]
  * Change maintainer address to debian-multimedia@lists.debian.org

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Switched build-system to dh
    * Set DEB_SRCDIR so the build-system can be found
  * Added patches
    * to pass LLVM-version to build
    * to protect the users' privacy
    * to fix spelling mistakes
  * Updated build-dependences (including llvm)
  * Updated Recommends (including clang)
  * Updated lintian-overrides
    * Removed unused overrides
    * Updated lintian-overrides for missing-sources
  * Removed sources for minified JS that is no longer included
  * Removed stray whitespace in d/changelog
  * Updated d/copyright
    * Added licensecheck target
    * Regenerated d/copyright_hints
    * Also fixed Files-Excluded for faust2
  * Use https:// for upstream homepage
  * Updated d/watch to point to github
  * Bumped dh-compat to 11
  * Bumped standards version to 4.3.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 09 Jan 2019 21:49:53 +0100
