=== debian/watch ===
version=3
opts=dversionmangle=s/~(dfsg|repack)(\.[0-9]*)?$// \
  https://github.com/grame-cncm/faust/releases .*/faust-(\d\S*)\.tar\.gz
